##########################
#                        #
#     STANDARD  LIB      #
#                        #
##########################

#
# ACCUMULATOR
#

ACC=0

#
# MEMORY
#

NEXTIDX=0

#
# STACK IMPLEMENTATION
#

STACKIDX=0
STACKIDXMAX=0

stackpush () {
  STACKIDX=$(($STACKIDX + 1))
  export STACK$STACKIDX="$ACC"

  # FOR DEBUG
  if [ $STACKIDX -gt $STACKIDXMAX ]
  then STACKIDXMAX=$STACKIDX
  fi
}

stackpop () {
  if [ $STACKIDX -eq 0 ]
  then echo "EROR: Empty Stack"
  else export "TMP"$1=$(deref "STACK$STACKIDX")
       STACKIDX=$(($STACKIDX - 1))
  fi
}


#
# CLOSURE
#

# mkclosure arity cmd
mkclosure () {
  if [ $1 -eq 0 ]
  then $2
  else NEXTIDX=$(($NEXTIDX + 1))
       ACC=VAR$NEXTIDX
       export $ACC="$1,$2"
  fi
}

# print closure
deref () {
  eval echo "\$$(echo $1)"
}

# closNArgs closure -> nargs
closNArgs () {
  deref "$1" | sed "s/^\([0-9]\+\),.*\$/\1/g"
}

# closCmd closure -> cmd
closCmd   () {
  deref "$1" | sed "s/^[0-9]\+,//"
}

# apply closure arg
apply () {
 CLOSURE="$ACC"
 ARG="$1"

 NARGS=$(closNArgs "$CLOSURE")
 CMD=$(closCmd "$CLOSURE")

 NARGS=$(($NARGS - 1))
 CMD="$CMD \"$ARG\""

 if [ $NARGS -eq 0 ]
 then eval $CMD
 else mkclosure $NARGS "$CMD"
 fi
}


